{-# OPTIONS_GHC -fglasgow-exts #-}

module Util where {

import List;
import Nat;
import HOL;
import Product_Type;

testPos :: forall a. (a -> Bool) -> [a] -> Bool;
testPos uu [] = False;
testPos f (x : xs) = f x || testPos f xs;

data Eithera a b = Lefta a | Righta b;

either_case :: forall a t b. (a -> t) -> (b -> t) -> Eithera a b -> t;
either_case f1 f2 (Righta b) = f2 b;
either_case f1 f2 (Lefta a) = f1 a;

data Cint = Neg Nat | Pos Nat;

unionI :: forall a. (Eq a) => [a] -> [a] -> [a];
unionI [] ys = ys;
unionI (x : xs) ys =
  let {
    zs = unionI xs ys;
  } in (if member x zs then zs else x : zs);

lookupa :: forall a b. (Eq a) => a -> [(a, b)] -> Maybe b;
lookupa uu [] = Nothing;
lookupa a ((a', b) : xs) = (if a == a' then Just b else lookupa a xs);

intToPos :: Integer -> Nat;
intToPos i = (if i <= 0 then Zero_nat else Suc (intToPos (i - 1)));

intToCint :: Integer -> Cint;
intToCint x = (if x < 0 then Neg (intToPos (negate x)) else Pos (intToPos x));

cint_case :: forall t. (Nat -> t) -> (Nat -> t) -> Cint -> t;
cint_case f1 f2 (Pos nat) = f2 nat;
cint_case f1 f2 (Neg nat) = f1 nat;

computeSplit :: forall a. (a -> Bool) -> [a] -> ([a], [a]);
computeSplit uu [] = ([], []);
computeSplit f (x : xs) =
  let {
    a = computeSplit f xs;
    (l, r) = a;
  } in (if f x then (x : l, r) else (l, x : r));

}
